//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1


//
//
//
//
//

extern int    AtrPeriod       = 14;
extern int    AtrMa_Mode      = 1;
extern int    MaPeriod        = 14;
extern int    Ma_Mode         = 1;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";
extern bool   ShowText        = true;
extern string TextDir         = "atrma Text";
extern int    textXPosition   = 5;
extern int    textYPosition   = 30;
extern color  tradeTextColor  = Green;
extern color  waitTextColor   = Gray;
extern int    tradeFontSize   = 12;
extern int    waitFontSize    = 12;

//
//
//
//
//

double UpH[];
double DnH[]; 
double atr[];
double atrma[];
double temp[];
double trend[];

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);  
   SetIndexBuffer(2,atr);
   SetIndexBuffer(3,atrma);
   SetIndexBuffer(4,temp);
   SetIndexBuffer(5,trend);
   IndicatorShortName("Atr Ma ("+AtrPeriod+","+MaPeriod+")");
return(0);
}
int deinit() 
{  
   ObjectDelete(TextDir);
return(0); 
}


//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)   temp[i] = MathMax(High[i],Close[i+1]) - MathMin(Low[i],Close[i+1]);
   for (i=limit; i>=0; i--) { atr[i]  = iMAOnArray(temp,Bars,AtrPeriod,0,AtrMa_Mode,i);  } 
   for (i=limit; i>=0; i--)   
   {
       atrma[i] = iMAOnArray(atr, Bars,MaPeriod,0,Ma_Mode,i); 
       UpH[i]   = EMPTY_VALUE;
       DnH[i]   = EMPTY_VALUE;
       trend[i] = trend[i+1];
       if(atr[i]>atrma[i]) { trend[i] = 1; Commenter(1);  }
       if(atr[i]<atrma[i]) { trend[i] =-1; Commenter(-1); }
       if (trend[i] == 1) UpH[i] = 1;
       if (trend[i] ==-1) DnH[i] = 1;
   }
    
   //
   //
   //
   //
   //
    
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Volatility increasing");
      else  doAlert("Volatility decreasing");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Atr_Ma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Atr_Ma "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//
//
//
//
//

void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
         ObjectSet(TextDir,OBJPROP_XDISTANCE,textXPosition);
         ObjectSet(TextDir,OBJPROP_YDISTANCE,textYPosition);
         if (Dir == 1) ObjectSetText(TextDir, "Trade", tradeFontSize,"Arial Black",tradeTextColor);
         if (Dir ==-1) ObjectSetText(TextDir, "Wait",  waitFontSize, "Arial Black",waitTextColor);
    }
}